const dotenv = require("dotenv");
const path = require('path')
require('dotenv').config({ path: path.resolve(__dirname, '../../.env') });
const Sequelize = require("sequelize");
const fs = require('fs');

const sequelize = new Sequelize(
 process.env.DB_name,
 process.env.DB_USER,
 process.env.DB_PASS,
 {
    host: process.env.host, //"mpsqldatabase.mysql.database.azure.com",
    dialect: process.env.DB_dialect,
    storage: process.env.DB_storage,
    logging: process.env.DB_logging,

    //  attributeBehavior?: 'escape' | 'throw' | 'unsafe-legacy';
    attributeBehavior: 'escape',
    dialectOptions: {
      ssl: {
         ca: fs.readFileSync(path.resolve(__dirname, '../cert/DigiCertGlobalRootCA.crt_3.pem')),
      },
    },
   },

);

sequelize.authenticate().then(() => {
   console.log(`Connection to ${process.env.DB_dialect} has been established successfully.`);
}).catch((error) => {
   console.error('Unable to connect to the database: ', error);
});

module.exports = { sequelize };

